version: "3.9"

services:
  # ------------------------------------------------------
  # PHP service (used only as dependency)
  # ------------------------------------------------------
  php:
    build:
      context: .
      dockerfile: docker/php/Dockerfile
    container_name: symfony_docker_php
    networks:
      - default
    restart: unless-stopped
    volumes:
      - ./:/var/www/html
    working_dir: /var/www/html

  # ------------------------------------------------------
  # PHP service (used only for running processes)
  # ------------------------------------------------------
  infinite:
      build:
        context: .
        dockerfile: docker/php/Dockerfile
      container_name: symfony_docker_infinite
      entrypoint: "tail -f /dev/null"
      networks:
        - default
      restart: unless-stopped
      volumes:
        - ./:/var/www/html
      working_dir: /var/www/html

  # ------------------------------------------------------
  # Exposed webserver
  # ------------------------------------------------------
  web:
    build:
      context: .
      dockerfile: docker/php/Dockerfile
    container_name: symfony_docker_web
    depends_on:
      - php
      - database
    labels:
      caddy: "api.noyeux-joel.aaa"
      caddy.tls: internal
      caddy.reverse_proxy: "{{upstreams 80}}"
    networks:
      - default
      - global_reverse_proxy
    restart: unless-stopped
    volumes:
      - ./:/var/www/html
    working_dir: /var/www/html

  # ------------------------------------------------------
  # PostgreSQL database
  # ------------------------------------------------------
  database:
    container_name: symfony_docker_database
    environment:
      POSTGRES_USER: "sdd"
      POSTGRES_PASSWORD: "sdd"
      POSTGRES_DB: "sdd"
    image: postgres:16.0
    networks:
      - default
    restart: unless-stopped
    volumes:
      - postgres_data:/var/lib/postgresql/data

  # ------------------------------------------------------
  # Database visualizer
  # ------------------------------------------------------
  adminer:
    container_name: symfony_docker_adminer
    depends_on:
      - database
    image: adminer
    labels:
      caddy: "db.noyeux-joel.aaa"
      caddy.tls: internal
      caddy.reverse_proxy: "{{upstreams 8080}}"
    networks:
      - default
      - global_reverse_proxy
    restart: unless-stopped
  
  # ------------------------------------------------------
  # Email infrastructure
  # ------------------------------------------------------
  mailer:
    container_name: symfony_docker_mailer
    image: maildev/maildev
    labels:
      caddy: "webmail.noyeux-joel.aaa"
      caddy.tls: internal
      caddy.reverse_proxy: "{{upstreams 1080}}"
    networks:
      - default
      - global_reverse_proxy
    restart: unless-stopped

  # ------------------------------------------------------
  # Cache infrastructure
  # ------------------------------------------------------
  cache:
    container_name: symfony_docker_cache
    image: redis:7.2
    networks:
      - default
    restart: unless-stopped

volumes:
  postgres_data: {}

networks:
  default:
    driver: bridge
  global_reverse_proxy:
    external: true
